class service {
  $basedir = '/tmp'
  file { "${service::basedir}/service.d": 
    ensure => directory,  
    purge => true, 
    recurse => true 
  }
  file{"${service::basedir}/service.d/00-service-base":
    source => '/etc/puppet/files/service-base',
  }
  exec { "rebuild-service":
    command => "/bin/cat ${service::basedir}/service.d/* > ${service::basedir}/service.conf",
    refreshonly => true,
    subscribe => File["${service::basedir}/service.d"]
  }
  # Simple management on the file itself.
  file { "${service::basedir}/service.conf":  
    mode => 644, 
    require => Exec[rebuild-service] 
  }
  define port($tcp = true, $udp = true, $comment ='', $port) {
    File{notify => Exec["rebuild-service"]}
    if $tcp == true {		
      file { "${service::basedir}/service.d/${port}-${name}-tcp":
        content => "$name  ${port}/tcp  $comment ",
      }	
    }
    if $udp == true {		
      file { "${service::basedir}/service.d/${port}-${name}-udp":
        content => "$name   ${port}/udp  $comment ",
      }
    }
  }
}

include service
service::port {'talk':
  port => 253,
}
service::port {'talk2':
  port => 2532,
  udp => false,
}
